:
# sulog.sh
# 2001-04-27 JKR copy of loginlog.sh, changed so that group=root

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001
#
# The copyright holder disclaims all responsibility or liability with
# respect to its usage or its effect upon hardware or computer
# systems, and maintains copyright as set out in the "LICENSE"
# document which accompanies distribution.
#
 
TITANHOME=`pwd`
MYNAME=`basename $0`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/var/adm/sulog'
RUNDATE=`/usr/bin/date +%Y%m%d%H%M`
OS=`uname -r`
LLOGFILE="/var/adm/sulog"

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh

if [ -x /usr/bin/nawk ];then
AWK=/usr/bin/nawk
elif [ -x /usr/bin/awk ];then
AWK=/usr/bin/awk
fi

Intro() {
cat << EOF_INTRO
 $MYNAME - This script checks for existence of /var/adm/sulog, 
 and whether its permissisons/ownership are 600 root:sys.
 It will create the file if it doesn't exist 
 and fix the permissions/ownership.

EOF_INTRO
}

Check() {

if [ -r "$LLOGFILE" ];then
/usr/bin/ls -ld $LLOGFILE 2> /dev/null | $AWK '{
                        if ($1 != "-rw-------" ) {
                        exit 1;
                                }
                        if ($3 != "root" ) {
                        exit 1;
                                }
                        if ($4 != "root" ) {
                        exit 1;
                                }
                      }'

      if [ $? -ne 0 ];then
       t_echo 0 "  $LLOGFILE params - FAILS CHECK"
      else
        t_echo 1 "  $LLOGFILE params - PASSES CHECK "
      fi
else  
   t_echo 0 "  $LLOGFILE missing - FAILS CHECK "
fi

}


Fix() {
if [ -f "$LLOGFILE" ];then :
else
   touch "$LLOGFILE"
fi
if chmod 600 "$LLOGFILE" && chown root "$LLOGFILE" && \
   chgrp root "$LLOGFILE" > /dev/null 2>&1 ; then
     t_echo 1 "  $LLOGFILE fixed - PASSES CHECK "
  else  
     t_echo 0 "  $LLOGFILE change params  - FAILS CHECK "
fi
}

 
action=$1
case $action in
 -[Ff]*)
Fix
;;
 -[Vv]*)
Check
;;
 -[Ii]*)
Intro
;;
 
*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
;;
esac

