:
# create-issue.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
RUNDATE=`/bin/date +%m%d%y%H%M%S`
SAVEFILES='/etc/security/login.cfg'
ISSUEFILE='/etc/security/login.cfg'
OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh

Intro() {
cat << EOF

 $MYNAME - This program creates a default entry in login.cfg so that upon 
 system login, users will be displayed a Warning Banner. This banner is 
 contained in the file "lib/issue-aix" by default. For AIX we insert it on
 the command line using chsec, and should be customized by the local System
 Administration Staff after consulting with the organization's legal staff.

EOF

}

Check() {
if [ -r ${ISSUEFILE} ]; then
  
 if [ -x /usr/bin/lssec ]; then
  HERALD=`/usr/bin/lssec -f ${ISSUEFILE} -s default -a herald | /usr/bin/awk -F"=" '{print $2}'`
   if [ -z "${HERALD}" ]; then
 t_echo 1 "        no security warning exists - FAILS CHECK"
	else
 t_echo 1 "        ${ISSUFILE} herald exists - PASSES CHECK"
 t_echo 2 "        Contents of ${ISSUEFILE} herald: "
 t_echo 2 " "
	/bin/echo ${HERALD}
 t_echo 2 " "
  fi
  else
   t_echo 1 "	Could not locate lssec command.. Passing.."
 fi
    else
      t_echo 2 "	Could not locate ${ISSUEFILE} - CHECK ERROR"
   fi
}


Fix() {

 t_echo 2 "        Building login banner... "

 if [ -r ${ISSUEFILE} ]; then
  /bin/cp ${ISSUEFILE} ${ISSUEFILE}-preTitan-${RUNDATE}

  if [ -r ../lib/issue-aix ]; then
  /usr/bin/awk '{printf("/usr/bin/chsec -f /etc/security/login.cfg -s default -a herald=\"%s\"",$0);}' ../lib/issue-aix >._herald.sh
	else
  /usr/bin/awk '{printf("/usr/bin/chsec -f /etc/security/login.cfg -s default -a herald=\"%s\"",$0);}' ./lib/issue-aix >._herald.sh
  fi
  /bin/sh ._herald.sh
  /bin/rm -f ._herald.sh

  HERALD=`/usr/bin/lssec -f /etc/security/login.cfg -s default -a herald | /usr/bin/awk -F"=" '{print $2}'`
   if [ -z "${HERALD}" ]; then
 t_echo 1 "        no security warning exists - FAILS CHECK"
	else
 t_echo 1 "        /etc/issue exists - PASSES CHECK"
 t_echo 2 "        Contents of /etc/issue: "
 t_echo 2 " "
	/bin/echo ${HERALD}
 t_echo 2 " "
  fi
    else
      t_echo 2 "	Could not locate ${ISSUEFILE} - FIX ERROR"
   fi
}

Undo() {

  /usr/bin/chsec -f /etc/security/login.cfg -s default -a herald=""

  HERALD=`/usr/bin/lssec -f /etc/security/login.cfg -s default -a herald | /usr/bin/awk -F"=" '{print $2}'`
   if [ -z "${HERALD}" ]; then
 t_echo 1 "        no security warning exists - FAILS CHECK"
	else
 t_echo 1 "        /etc/issue exists - PASSES CHECK"
 t_echo 2 "        Contents of /etc/issue: "
 t_echo 2 " "
	/bin/echo ${HERALD}
 t_echo 2 " "
  fi
}


action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	-[Bb]*)
	Backup
	;;
	-[Uu]*)
	Undo
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivfbr] (I)ntro/(V)erify/(F)ix/(B)ackup/(U)ndo"
        t_echo 1 " "
	;;
	esac
