:
# ftp-2.6_secure.sh
# version 3.1.2 bpowell Tue May 25 15:48:36 PDT 1999 
# version 3.2.1 bpowell Fri Oct  1 12:37:12 PDT 1999 backticks in banner line 
# instead of apostrphes
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
RUNDATE=`/bin/date +%m%d%y%H%M%S`
SAVEFILES='/etc/ftpaccess.ctl /etc/ftp-banner'
FTPCONF='/etc/ftpaccess.ctl'
#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh


# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi


Intro() {

cat << EOF

 
$MYNAME : Changes or creates /etc/ftpaccess.ctl file to add in a umask and
ftp banner. Changes or creates /etc/ftp-banner with the following content.
Anything more tends to create issues with some ftp clients, unless explicitly
run with -n. So, minimal herald avoids pain for users and protects your asset
needs:

	Access for authorized users only. Monitoring may occur.

EOF

}

Check() {

if [ -f ${FTPCONF} ]; then
  HERALD=`grep -i herald ${FTPCONF} | awk -F":" '{print $2}'` 

   if [ -z "${HERALD}" ]; then
       t_echo 0 "       No herald message file in ${FTPCONF} - FAILS CHECK"
       exit 1
     else
   if [ -r ${HERALD} ]; then
       t_echo 1 "	Herald file = ${HERALD} -  PASSES CHECK" 
   else
       t_echo 1 "	Herald file = ${HERALD} defined, but does not exist - FAILS CHECK"
   fi
   fi

if [ -f ${HERALD} ]; then
  grep "[A-z]" ${HERALD}
    if [ $? -eq 0 ]; then
      t_echo 1 "       ${HERALD} has message - PASSES CHECK"
      t_echo 1 "	Herald message content: "
      t_echo 1 "	`/bin/cat ${HERALD}`" 
    else
      t_echo 0 "       ${HERALD} has no content - FAILS CHECK"
    fi 
fi
  else
	t_echo 0 "  ${FTPCONF} does not exist -  FAILS CHECK" 
fi

}


Fix() {


create_banner() {
echo " Access for authorized users only. Monitoring may occur. " >/etc/ftp-banner
}

create_ftpaccess() {
/usr/bin/touch /etc/ftpaccess.ctl
echo "herald : /etc/ftp-banner" >>/etc/ftpaccess.ctl
}


if [ -f ${FTPCONF} ]; then
 /bin/cp ${FTPCONF} ${FTPCONF}-preTitan-${RUNDATE}
  HERALD=`grep -i herald ${FTPCONF} | awk -F":" '{print $2}'` 

   if [ -z "${HERALD}" ]; then
       t_echo 0 "       No herald message file in ${FTPCONF} - FAILS CHECK"
       t_echo 1 "	Creating file and content in /etc/ftp-banner"
       create_ftpaccess
       create_banner
     else
   if [ -r ${HERALD} ]; then
       t_echo 1 "	Herald file = ${HERALD} -  PASSES CHECK" 
   else
       t_echo 1 "	Herald file = ${HERALD} defined, but does not exist - FAILS CHECK"
       t_echo 1 "	Creating file = ${HERALD}"
       create_ftpaccess
       create_banner

        /bin/touch ${HERALD}
	if [ $? -eq 0 ]; then
	 t_echo 1 "	${HERALD} Created - PASSES CHECK"
        else
	 t_echo 1 "	Could not create ${HERALD} - FAILS CHECK"
        fi
   fi
   fi

if [ -f ${HERALD} ]; then
  grep "[A-z]" ${HERALD}
    if [ $? -eq 0 ]; then
      t_echo 1 "       ${HERALD} has message - PASSES CHECK"
      t_echo 1 "	Herald message content: "
      t_echo 1 "	`/bin/cat ${HERALD}`" 
    else
      t_echo 0 "       ${HERALD} has no content - FAILS CHECK"
      t_echo 0 "       Creating content in ${HERALD}"
      create_banner ${HERALD}
    fi 
fi
  else
	t_echo 0 "	${FTPCONF} does not exist -  FAILS CHECK" 
	t_echo 0 "	Creating ${FTPCONF} and herald file"
        create_ftpaccess
	create_banner
fi

Check
}

action=$1

   case ${action} in
	-[Ii]*)
	Intro
	;;
	-[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $0 -[ivf] (I)ntro/(V)erify/(F)ix"
	exit 1;;
	esac

