:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

# Modified Oct 2000 to work for Red Hat 6.2
# Erik Ginorio <eginorio@cisco.com>

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with
# respect to its usage or its effect upon hardware or computer
# systems, and maintains copyright as set out in the "LICENSE"
# document which accompanies distribution.
#
#This module modified by Mitko Stoyanov, August 1999
 
 
TITANHOME=`pwd`
MYNAME=`basename $0`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
DATE=`/bin/date +%m%d%y%H%M`
OS=`uname -r`

LLOGFILE="/var/log/lastlog"

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh

if [ -x /usr/bin/nawk ];then
AWK=/usr/bin/nawk
elif [ -x /usr/bin/awk ];then
AWK=/usr/bin/awk
fi

Intro() {
cat << EOF_INTRO
This script checks for existence of /var/log/lastlog, 
and whether its permissisons/ownership are 600 root:root.
It will create the file if it doesn't exist and fix the
permissions/ownership if needed.

EOF_INTRO
}

Check() {

if [ -e "$LLOGFILE" ];then
/bin/ls -ld $LLOGFILE 2> /dev/null | $AWK '{
                        if ($1 != "-rw-------" ) 
                        { exit 1 }
                        if ($3 != "root" ) 
                        { exit 1; }
                        if ($4 != "root" ) 
                        { exit 1; }
                      }'
      if [ $? -ne 0 ];then
       t_echo 0 "  $LLOGFILE permissions/ownership is wrong - FAILS CHECK"
       ls -ld $LLOGFILE
      else
        t_echo 2 "  $LLOGFILE permissions/ownership is correct - PASSES CHECK "
      fi
else  
   t_echo 0 "  $LLOGFILE missing - FAILS CHECK "
fi

}


Fix() {
if [ -f "$LLOGFILE" ];then :
else
   touch "$LLOGFILE"
fi
if chmod 600 "$LLOGFILE" && chown root:root "$LLOGFILE"; then 
     t_echo 2 "  $LLOGFILE permissions/ownership fixed - PASSES CHECK "
  else  
     t_echo 2 "  $LLOGFILE change permissions/ownership failed  - FAILS CHECK "
fi
}

 
action=$1
case $action in
 -[Ff]*)
Fix
;;
 -[Vv]*)
Check
;;
 -[Ii]*)
Intro
;;
 
*)
        echo "        ERROR:Invalid arg $action"
        echo "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
 
        echo " "
;;
esac



# List all files to save prior to changes this modules might make.
# Syntax is SAVEFILES='foo bar foobar'
#
SAVEFILES='/var/adm/loginlog'
