#!/bin/sh
# :
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`

OS=`uname`

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

case $OS in
  5*)
   PASSFILE=/etc/shadow
  ;;
  4*|*inux)
   if [ -f /etc/shadow ]; then
   PASSFILE=/etc/shadow
   else
   PASSFILE=/etc/passwd
   fi
  ;;
 *)
   t_echo 1 "	No valid OS for password check"
   exit 1
;;
esac

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

Intro() {

cat << EOF

 This program verifies that all accounts have passwords in
 either /etc/passwd or /etc/shadow as appropriate for the
 current OS... Using $PASSFILE on this host....

EOF

}


FixPasswd() {

BADPASS=`grep "^[^:]*::" ${PASSFILE}`

if [ "$BADPASS" ]; then
	for PASS in $BADPASS
	do
            t_echo 0 $PASS
	done
        t_echo 0
        t_echo 0 "The above accounts have no password - Locking now..."
	ed - ${PASSFILE} <<- !
	g/^[^:]*::/s/::/:*:/
	w
	q
	!
        t_echo 2
        t_echo 2 "Done..."
else
        t_echo 2 "All accounts have passwords - PASSES CHECK"
fi

}

CheckPasswd() {

ALLPASS=`grep "^[^:]*::" ${PASSFILE}`

if [ "$ALLPASS" ]; then
	for PASS in $ALLPASS
	do
        t_echo 0 $PASS
	done
        t_echo 0
        t_echo 0 "The above accounts have no password - FAILS CHECK"
else
        t_echo 2 "All accounts have passwords - PASSES CHECK"
	exit 0
fi

}

action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	CheckPasswd
	FixPasswd
	CheckPasswd
	;;
	-[Vv]*)
	CheckPasswd
	exit 0
	;;
	*)
        t_echo 1 " ERROR:Invalid arg $action"
        t_echo 1 " ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
	;;
	esac


# List all files to save prior to changes this modules might make.
# Syntax is SAVEFILES='foo bar foobar'
#
SAVEFILES='/etc/shadow'
