#!/bin/sh
# :
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`

OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi
 
#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro() {
 
cat << EOF

 This program Checks utmp, utmpx for world write permissions
 if found resets permissions to 'o-w'


EOF
}
 

FixUtmp() {

for FILE in utmp utmpx
 do
if [ `ls -lL /var/run/${FILE} |grep -s "^........w"` ]; then
        t_echo 0 "  File utmp writable - Fixing permissions..."
                chmod o-w /var/run/${FILE}
else
        t_echo 2 "  File utmp permissions set to o-w - Done..."
fi
done

t_echo 2
}


VrfyUtmp() {

for FILE in utmp utmpx
 do
if [ `ls -lL /var/run/${FILE} |grep -s "^........w"` ]; then
        t_echo 0 "        File utmp writable - FAILS CHECK"
else
        t_echo 2 "        File utmp permissions o-w - PASSES CHECK"
fi
done

t_echo 2
}

action=$1
case $action in
	-[Ii]*)
	Intro
	;;
	-[Ff]*)
	FixUtmp
	;;
	-[Vv]*)
	VrfyUtmp
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
;;
esac


# List all files to save prior to changes this modules might make.
# Syntax is SAVEFILES='foo bar foobar'
#
SAVEFILES='/var/run/utmp /var/run/utmpx'
