:
#
umask 022

# This tool suite was written by and is copyright by Brad Powell , Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 
 
# Some of the ideas and code for the sunos 4.1.X version of titan was 
# modified from code from a program secure_sun author unknown. If the 
# author of secure_sun (i believe it was from Texas A&M) wishes to identify 
# himself/herself I will gladly post credit where it is due- bpowell
 

inetdconf="/etc/inet/inetd.conf"
#inetdconf="inetd.conf"

# setup
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
OS=`uname -r`
HOST=`uname -n`
DATE=`/bin/date +%H%M%S`

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
	# exit 1
	:
	fi

Intro() {

cat << EOF_INTRO

A more restrictive version of inetd.sh. Disables all but telnet and ftp in
$inetdconf, since they give out information or are potential "denial of
service" problems, like rexd, finger, systat, netstat, rusersd, sprayd,
and walld.

EOF_INTRO

}

Check() {
 
if egrep -s "^finger|^talk|^comsat|^shell|^login" $inetdconf
then
   t_echo 2 " File $inetdconf has services running that should be disabled: FAILS CHECK"
else
   t_echo 2 " $inetdconf seems to have had services disabled: PASSES CHECK"

fi

}

Fix() {

if [ -f $inetdconf.ORIG ]
	then
	t_echo 2 "File $inetdconf.ORIG already exists; not changing"
else
	t_echo 2 "moving $inetdconf to $inetdconf.ORIG.$DATE"
	/bin/mv $inetdconf $inetdconf.ORIG.$DATE
	if [ $? -ne 0 ]
		then   
		t_echo 2
		t_echo 2 "Could not rename inetd.conf"
		exit 1
		fi
	fi

if [  ! -f $inetdconf ]
	then
	t_echo 2 "Changing $inetdconf to the new version"
	t_echo 2 "Note: You may have to manually edit inetd if you add"
	t_echo 2 "non-standard services."
	t_echo 2 "The existing version is saved as $inetdconf.ORIG.$DATE"
	t_echo 2 ""
	t_echo 2 " YOU SHOULD REALLY LOOK TO USING ssh or logdaemon!"

/bin/cat << EOF_INET > $inetdconf

# Configuration file for inetd(8).  See inetd.conf(5).
#
# To re-configure the running inetd process, edit this file, then
# send the inetd process a SIGHUP.
#
# Internet services syntax:
#  <service_name> <socket_type> <proto> <flags> <user> <server_pathname> <args>
#
# Ftp and telnet are standard Internet services.
#
ftp        stream  tcp     nowait  root    /usr/etc/in.ftpd   in.ftpd -l
telnet  stream  tcp     nowait  root    /usr/etc/in.telnetd     in.telnetd
EOF_INET

	/bin/chmod 644 $inetdconf
	fi

}

action=$1
case $action in
 -[Ff]*)
Fix
;;
 -[Vv]*)
Check
;;
 -[Ii]*)
Intro
;;
 
*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
;;
esac

