:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022

# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 
 
# $RCSfile: mkshadow,v $ $Revision: 1.6 $
# $Date: 90/04/28 23:44:31 $
# $Author: leadley $
#
#	Scott Leadley, University of Rochester, 4/24/90
#
# $modified bpowell 90-06-30
# $modified and then changed to fit titan: bpowell 96-04-16

TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh
 
Intro() {

cat  << EOF_INTRO

 Start up the SunOS 4.1.X shadow password utility without bothering with
 the C2 auditing.  This script is a little more paranoid that the Sun
 supplied C2conv:
EOF_INTRO
}

 
Check() {

if [ -f /etc/security/passwd.adjunct ] ; then
	t_echo 2 "   The system has already been set up to shadow passwords"
	t_echo 2 "   PASSES CHECK"
else
	t_echo 0 " Shadowed passwords have not been installed. FAILS CHECK"
fi
}

Fix() {
#
#	The C2 security package must be installed (or at least rpc.pwdauthd).
if [ ! -x /usr/etc/rpc.pwdauthd ]; then
	t_echo 1 "The C2 security package is not installed."
	t_echo 1 " We need /usr/etc/rpc.pwdauthd to proceed. Either install the"
	t_echo 1 " C2 package, or get the patch from Sun that contains /usr/etc/rpc.pwdauthd"
	exit 1
 
fi
#

if [ ! -d /etc/security ]; then
	mkdir /etc/security
	( cd /; rpc.pwdauthd & )
	pwdauthd_started_by_hand=$TRUE
	t_echo 0 "rpc.pwdauthd started.  Started by /etc/rc.local from now on."
fi
   chown root.wheel /etc/security
   chmod 711 /etc/security; chmod g+s /etc/security

if [ ! -f /etc/security/passwd.adjunct ]; then
	touch /etc/security/passwd.adjunct
	if [ $pwdauthd_started_by_hand -eq $FALSE ]; then
		( cd /; rpc.pwdauthd & )
		pwdauthd_started_by_hand=$TRUE
		t_echo 0 "rpc.pwdauthd started.  Started by /etc/rc.local from now on."
	fi
else
	t_echo 1 "/etc/security/passwd.adjunct already exists!"
fi

   chown root.wheel /etc/security/passwd.adjunct
   chmod 600 /etc/security/passwd.adjunct
 
   cp /etc/passwd /etc/passwd.bak
 if [ $? -ne $TRUE ]; then
	t_echo 1 "Couldn't backup /etc/passwd to /etc/passwd.bak.  Too dangerous to proceed."
	exit 1
fi
chown root.wheel /etc/passwd.bak
chmod 400 /etc/passwd.bak
 
 
EDITOR=ex
export EDITOR
vipw >/dev/null <<EOF
1,\$! awk -F: '{printf "\%s:\%s:::::\n", \$1, \$2;}'
/^audit:/d
1put
1d
1put
1s/\$/all/
g/^+/d
w! /etc/security/passwd.adjunct
e!
1,\$! awk -F: '{if(\$1~/^\+/)print;else printf "\%s:\#\#\%s:\%s:\%s:\%s:\%s:\%s\n", \$1, \$1, \$3, \$4, \$5, \$6, \$7;}'
w!
q
EOF
egrep '^\+' /etc/passwd >/dev/null
if [ $? -eq $TRUE ]; then
	t_echo 1 "NIS (YP) passwd entries need to be added to the shadow password file by hand."
fi
#
#	Reminder to comment out the auditd startup in /etc/rc.local.
t_echo 0 "Remember to comment out or delete the auditd startup in /etc/rc.local:"
t_echo 0
sed -n "/auditd/,/fi/s/^/   /p" /etc/rc.local

}

action=$1
case $action in
 -[Ff]*)
Fix
;;
 -[Vv]*)
Check
;;
 -[Ii]*)
Intro
;;

*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"

        t_echo 1 " "
;;
esac

