:
# create-motd.sh
# 2001-04-27 JKR copy of create-issue.sh

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/motd'
OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh

Intro() {
cat << EOF

 $MYNAME - This program creates a default /etc/motd file so that upon system
 login, users will be displayed a Warning Banner. This banner is contained
 in the file "lib/issue", and should be customized by the local System 
 Administration Staff after consulting with the organization's legal staff.
 Because some users will not see the issue (e.g., those logging in with some
 ssh clients), this is a good complement to create-issue.sh

EOF

}

Check() {
 t_echo 1 "        /etc/motd exists - PASSES CHECK"
 t_echo 2 "        Contents of /etc/motd: "
 t_echo 2 " "
	/bin/cat /etc/motd
 t_echo 2 " "
}

Fix() {

if [ -f /etc/motd ]; then
 Check
else
 t_echo 2 "        Building /etc/motd... "
if [ -f ./lib/issue ]; then
/bin/cat ./lib/issue >/etc/motd
else
/bin/cat issue > /etc/motd
fi

if [ -f /etc/motd ]; then   
 t_echo 2 ""
 t_echo 2 "        File /etc/motd created"
 t_echo 2 "        Contents of /etc/motd: "
 t_echo 2 " "
	/bin/cat /etc/motd
 t_echo 2 ""
fi 
fi
}


action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	Fix
	;;
	-[Vv]*)
	if [ -f /etc/motd ]; then
	   Check
	else
           t_echo 0 "        Cannot read /etc/motd - FAILS CHECK"
	   exit 1
	fi
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
	;;
	esac
