:
# adjust.syn-timeout.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.0.3 Fri Jan  8 12:42:25 PST 1999 bpowell; for FILE loop in Fix()
# version 3.3 Sat Aug  15 12:00:05 PST 1999 bpowell; syntax errors in Fix()
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 
#

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/rc2.d/S??inet'

OS=`uname -r`

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

 case "`uname -r`" in
 5.[234]*) ;;
 *)
         t_echo 1 "$MYNAME : ERROR - This script is Only needed on Solaris 2.4 and older "
         t_echo 1 " please see Sun's patch (Patch 103582-11 currently) for a better fix"
         exit 1;;
 esac

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

Intro() {
cat << EOF

 $MYNAME : This changes the system configuration to shorten the 
 Abort Timeout Value to ten seconds. THIS MAY NEED TO BE INCREASED for systems 
 servicing asynchronous lines.

 The program modifies /etc/rc2.d/S??inet adding in the lines:

	ndd -set /dev/tcp tcp_ip_abort_cinterval 10000
	echo "tcp_param_arr+14/W 0t10240" | adb -kw /dev/ksyms /dev/mem
	ndd -set /dev/tcp tcp_conn_req_max 8192

 Note: this is a minor hack. normal instructions say to put the
 adb line in /etc/init.d/inetinit however the starting sequence
 is wrong if it is put there.

EOF

}

Fix() {
	if [ -f /etc/rc2.d/S??inet -o /etc/rc3.d/S??inet ]; then
	for FILE in `ls /etc/rc*.d/S??inet`
	do
	egrep '(tcp_ip_abort_cinterval|tcp_conn_req_max|tcp_param_arr)' $FILE >/dev/null 2>&-

	if [ $? -eq 0 ]; then
   	t_echo 1 "Entries in $FILE already exist - PASSES CHECK"
	exit 1
  	else
        t_echo 2 " Adding lines"
	t_echo 2 " ndd -set /dev/tcp tcp_ip_abort_cinterval 10000"
   	t_echo 2 " tcp_param_arr+14/W 0t10240 | adb -kw /dev/ksyms /dev/mem"
   	t_echo 2 " ndd -set /dev/tcp tcp_conn_req_max 8192"
   	t_echo 2 " to /etc/rc2.d/S??inet"
   	t_echo 2 "    "

ed - $FILE <<- !
a
	ndd -set /dev/tcp tcp_ip_abort_cinterval 10000
.
w
a
	echo "tcp_param_arr+14/W 0t10240" | adb -kw /dev/ksyms /dev/mem
.
w
a
	ndd -set /dev/tcp tcp_conn_req_max 8192
.
w
q
!
fi
done
fi
}

Check() {
if [ -f /etc/rc2.d/S??inet ]; then
  t_echo 2 "    "
  t_echo 2 "    Checking for tcp abort in /etc/rc2.d/S??inet"
  t_echo 2 "    "
  egrep '(tcp_ip_abort_cinterval|tcp_conn_req_max|tcp_param_arr)' /etc/rc2.d/S??inet >/dev/null 2>&-
  if [ $? -eq 0 ]; then
  t_echo 2 "    "
  t_echo 1 "        Tcp options have already been set - PASSES CHECK"
  t_echo 2 "    "
  else
  t_echo 0 "        Tcp abort is not set - FAILS CHECK"
  t_echo 2 "    "
 fi
 else
  t_echo 1 "No file /etc/rc2.d/S??inet found - ERROR"
fi
}

action=$1
case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
;;
esac
