:
#
# version 3.6 Wed April 19 08:33:18 PST 2000
# version 4.0.10 Wed May 02 06:04:11 PST 2001
# version 4.0.beta1 Tue Jul 31 12:04:23 PDT 2001

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 
#
# 2001-04-24 JKR Modify fix to keep original file in same directory, alert if can't find file
#	also modify check to warn if can't find file
#	and not change if syslog line has whitespace before it.
#
# KWH fix to reference /etc/init.d/syslog instead of /etc/init.d/syslog
# and also added a couple of lines to stop, then start the syslog daemon

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/init.d/syslog'

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

 
case "`uname -r`" in
5.[89]*) ;;
*)
        t_echo 1 "ERROR - This script is Only supported on Solaris 2.8 and newer"
        exit 1;;
esac
 

Intro() {

cat << EOF

 
Changes the /etc/init.d/syslog to start syslog with the "-t" flag, This script
should NOT be run on the LOGHOST syslogd system but on every other system that
you don't want black-hats flooding your local syslogd.
Note: LOGHOST should be protected by a firewall mechanism since it is a UDP service.

 From the syslogd man page:


     -t    Disable the syslogd UPD port to turn off logging of
           remote messages.

EOF

}

Fix() {

 if [ -f /etc/init.d/syslog ]; then
    #JKR grep -i "^\/usr\/sbin\/syslogd\ \-t" /etc/init.d/syslog
    grep -s "^\	\	\/usr\/sbin\/syslogd\ \-t*" /etc/init.d/syslog >/dev/null 2>&-
    if [ $? -eq 0 ]; then
       t_echo 2 " /etc/init.d/syslog is already running -t  - Not Changing"
       exit 1
    else
       if [ -f /etc/init.d/syslog ]; then
          t_echo 2 " Saving /etc/init.d/syslog to /etc/init.d/syslog.ORIG.${DATE}"
          cp /etc/init.d/syslog /etc/init.d/syslog.ORIG.${DATE}
	  if [ $? -ne 0 ]; then
             t_echo 1 "     Could not save file to /etc/init.d/syslog.ORIG.${DATE} - ERROR"
             exit 1
	  else
	     t_echo 2     " Changing syslog startup default "
ed /etc/init.d/syslog <<- EDEND
g/^\	\	\/usr\/sbin\/syslogd/s//\	\	\/usr\/sbin\/syslogd\ \-t/
.
w
q
EDEND
             t_echo 2 " syslogd startup in /etc/init.d/syslog changed ... "
             t_echo 2 " syslogd is being restarted now with the new config ... "
             /etc/init.d/syslog stop
             /etc/init.d/syslog start
          fi
       fi
    fi
 else
    t_echo 1 "     WARNING -- Could not find /etc/init.d/syslog"
 fi

}

Check() {

        if [ -f /etc/init.d/syslog ]; then
	grep -s "^\	\	\/usr\/sbin\/syslogd\ \-t*" /etc/init.d/syslog >/dev/null 2>&-
	if [ $? -eq 1 ]; then
 	 t_echo 0 "       /etc/init.d/syslog - has the system default . - FAILS CHECK"
        t_echo 3 " "
        t_echo 3 "Titan Recommendation: (syslog-block-remote.sh -f) Chang /etc/rc2.d/S74syslog"
        t_echo 3 "such that syslog is started  with the "-t" flag, This script should NOT be run on"  
        t_echo 3 "the LOGHOST syslogd system but on every other system that you don't want"
        t_echo 3 "black-hats flooding your local syslogd. "
        t_echo 3 "Note: LOGHOST should be protected by a firewall mechanism "
        t_echo 3 " "
        t_echo 3 " From the syslogd man page: "
        t_echo 3 " "
        t_echo 3 " "
        t_echo 3 "     -t    Disable the syslogd UPD port to turn  off  logging  of "        t_echo 3 "           remote messages. "
        t_echo 3 " "
        t_echo 3 "======================================================================== "

         else
	t_echo 1 " /etc/init.d/syslog starts up syslog with the -t option - PASSES CHECK"
	fi
	else
	   t_echo 1	"Warning -- can't find /etc/init.d/syslog"
         fi
}

action=$1

   case ${action} in
	-[Ii]*)
	Intro
	;;
	-[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $0 -[ivf] (I)ntro/(V)erify/(F)ix"
	exit 1;;
	esac

