:
# disable-L1-A.sh
# version 3.0  Sept 25 12:00 PST 1998  bpowell
# version 3.0.5 Wed Feb 24 10:41:38 PST 1999 fixed up the write/quit
#               so that it worked 100% of the time - bpowell
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0.10 Thu Apr  5 14:42:17 PDT 2001

umask 022
# This tool suite was written by and is copyright by Brad Powell , Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/default/kbd'

. misc_functions.sh

case "`uname -r`" in
5.[6789]*) ;;
*)
        t_echo 1 "$MYNAME ERROR - This script is Only supported on Solaris 2.6 and newer " 1>&2
        exit 1;;
esac

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi
 
Intro() {

cat << EOF
 $MYNAME - This disables the L1-A or stop-A keyboard sequence by modifying
 /etc/default/kbd. The change will not take affect until after a reboot.
or until a "/usr/bin/kbd -i" is run.

 The line added is :
 
 KEYBOARD_ABORT=disable
 
EOF
}

Fix() {
if  [ -f /etc/default/kbd ] ; then
		t_echo 2 "        Disabling the abort sequence "

		ed - /etc/default/kbd <<- ENDED
		a
		KEYBOARD_ABORT=disable
		.
		w
		q
		ENDED

        t_echo 2 "	Modifcations to /etc/default/kbd complete"
        t_echo 2 "	Running /usr/bin/kbd -i now"
	kbd -i
fi

}

Check() {
   grep "^KEYBOARD_ABORT=disable" /etc/default/kbd >/dev/null 2>&-
   if [ $? -eq 0 ]; then
    t_echo 1 "         Abort sequence set to disable  - PASSES CHECK"
   else
    t_echo 0 "         Abort sequence set to enable - FAILS CHECK"
        t_echo 3 " "
        t_echo 3 "Titan Recommendation: (disable-L1-A.sh -f) This is a physical access issue."
        t_echo 3 "If a person can abort the current Solaris session, and reboot using an "
        t_echo 3 "alternate device, (see eeprom.sh -f) they can access/modify any file."
        t_echo 3 "Titan sets abort sequence to: "
        t_echo 3 " "
        t_echo 3 "KEYBOARD_ABORT=disable in /etc/default/kbd "
        t_echo 3 " "
        t_echo 3 "======================================================================== "

    exit 1
   fi
 
}


action=$1
case ${action} in
-[Ii])
Intro
;;
-[Ff]*)
Fix 
;;
-[Vv]*)
Check
;;
*)
        t_echo 0 "         ERROR:Invalid arg $action"
        t_echo 0 "         ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
;;
esac
