:
# ssh-banner.sh
# version 4.0 BETA4 June 16, 2002

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2002
#
# The copyright holder disclaims all responsibility or liability with
# respect to its usage or its effect upon hardware or computer
# systems, and maintains copyright as set out in the "LICENSE"
# document which accompanies distribution.

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/ssh/sshd_config'
OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh

Intro() {

cat << EOF

 $MYNAME - This program checks/sets the sshd_config file so that it shows the /etc/issue
 BANNER contents on ssh login.
 
EOF
}
 
#
# Fix it
Fix() {
 
 if [ `grep -cs "^#Banner*" /etc/ssh/sshd_config` -ge 1 ]; then
	t_echo 2 " Banner is not enabled; fixing"
	t_echo 2 "Saving default sshd_config as /etc/ssh/sshd_config.ORIG.$DATE"
      cp -p /etc/ssh/sshd_config /etc/ssh/sshd_config.ORIG.$DATE
   # now we fix it 
ed - /etc/ssh/sshd_config << EOF
g/^#Banner\ \/etc\/issue/d
60
a
Banner /etc/issue
.
w
q
EOF
 fi
}


Check() {

grep "^Banner" /etc/ssh/sshd_config
 if [ $? -eq 0 ]; then
   t_echo 1 "sshd displays a banner  - PASSES CHECK"
 
 else
   t_echo 1 "Sshd does not display a login banner - FAILS CHECK"
   t_echo 3 " "
   t_echo 3 "Titan Recommendation: (ssh-banner.sh -f) Change /etc/ssh/sshd_config "
   t_echo 3 "to display /etc/issue by changing; "
   t_echo 3 "#Banner  TO Banner /etc/issue"
   t_echo 3 " "
   t_echo 3 "===================================================================="

 fi
   exit 1
}
 
#
# Main section here
 
action=$1
case $action in
        -[Ii]*)
        Intro
        ;;
         -[Ff]*)
          Fix
         ;;
         -[Vv]*)
          Check
         ;;
         *)
         t_echo 1 " "
         t_echo 1 "        ERROR:Invalid arg $action"
         t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
         t_echo 1 " "
        ;;
esac

