:
# x-nolisten.sh
#  version 4.0. June 16, 2002

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2002
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/usr/dt/config/Xservers'

. misc_functions.sh

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

Intro() {

cat << EOF
 
 $MYNAME - Changes the X startup configuration to not listen for remote
 X connections, by adding "-nolisten tcp" to the X startup file in the
 /usr/dt/config/Xservers file. This does not prevent the X server (cde/gnome)
from running, only prevents remote persons from connecting.

FROM:
   :0 Local local_uid@console root /usr/openwin/bin/Xsun :0 -nobanner

TO:
   :0 Local local_uid@console root /usr/openwin/bin/Xsun :0 -nobanner -nolisten tcp

EOF

}

Fix() {

 if [ -f /usr/dt/config/Xservers ]; then
        grep -i "\-nolisten tcp" /usr/dt/config/Xservers
        if [ $? -eq 0 ]; then
	t_echo 2 " /usr/dt/config/Xservers is already running secure - Not Changing"
	exit 1
	else
        if [ -f /usr/dt/config/Xservers ]; then
        t_echo 2 "Saving /usr/dt/config/Xservers to /usr/dt/config/Xservers.ORIG.${DATE}"
        cp -p /usr/dt/config/Xservers /usr/dt/config/Xservers.ORIG.${DATE}
	if [ $? -ne 0 ]; then
           t_echo 1 "Could not save file to /usr/dt/config/Xservers.ORIG.${DATE} - ERROR"
           exit 1
	else
	t_echo 2     " Changing Xserver startup default "
	ed /usr/dt/config/Xservers <<- EDEND
	g/\-nobanner/s//\-nobanner\ \-nolisten\ tcp/g
	.
        w
	q
	EDEND
           t_echo 2 " Xservers startup in /usr/dt/config/Xservers changed ... "
          fi
        fi
	fi
 fi

}

Check() {

        if [ -f /usr/dt/config/Xservers ]; then
	grep -i "\-nolisten tcp" /usr/dt/config/Xservers
        if [ $? -eq 0 ]; then
        t_echo 0 " /usr/dt/config/Xservers is running secure - PASSES CHECK"

         else
         t_echo 1 "  /usr/dt/config/Xservers is not running secure: - FAILS CHECK" 
        t_echo 3 " "
        t_echo 3 "Titan Recommendation: (x-nolisten.sh -f) The X Server does not"
        t_echo 3 "commonly need to listen for remote connections"
        t_echo 3 "edit /usr/dt/config/Xservers and change: "
        t_echo 3 "    FROM: "
        t_echo 3 ":0   Local local_uid@console root /usr/openwin/bin/Xsun :0 -nobannera"
        t_echo 3 "    TO: "
        t_echo 3 ":0   Local local_uid@console root /usr/openwin/bin/Xsun :0 -nobanner -nolisten tcp"
        t_echo 3 " "
        t_echo 3 "====================================================================== "

	fi
         fi
}

action=$1

   case ${action} in
	-[Ii]*)
	Intro
	;;
	-[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $0 -[ivf] (I)ntro/(V)erify/(F)ix"
	exit 1;;
	esac

