:
#
# version 3.0 Sep 25 11:21:02 PDT 1998
# rev 3.01 Tue Nov  3 17:46:47 PST 1998
#       zen - changed /usr/ucb/echo -n to nawk stuff.
# rev 3.02 Sun Dec  26 14:32:32 PST 1999
#       matt - re-write of the search code to use a module variable "SAVEFILES"
#	matt - added file checking for -c,-b,-p types to avoid previous problems
#	       with /dev/ip etc...
#	matt - added getfacl for untit.sh to use setfacl for permission change
#	       tracking as requested by Dan... :>) Better late than never...

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000 
#
# The copyright holder disclaims all responsibility or liability with
# respect to its usage or its effect upon hardware or computer
# systems, and maintains copyright as set out in the "LICENSE"
# document which accompanies distribution.
#

# Looks in modules for tha standard SAVEFILES variable. Takes everything to
# the right of the "=" sign as a list of files to backup. Burns the single
# quotes from the remaining string and backs up as normal.

# Now checks for char/block/pipe special files. Passes on these such that
# looking for /dev/ip, /dev/kmem, /dev/zero etc... are no longer required.

# Runs the getfacl command and saves all current setting to the SAVEFILE for
# use by untit.sh and to allow us to set a default perm of 600 on all files
# backed up. In this way the backed up files cannot be executed to circumvent
# the desired security configuration and/or exploit bugs if they exist

TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib

#
# Include some meaningful stuff and includes from lib
#
. $TITANHOME/lib/misc_functions.sh
DATE=`/bin/date +%m%d%y%H%M`
export DATE
BACKDIR=$TITANHOME/../Backup/$HOST/$DATE
BACKFILE=${TITANHOME}/FBACKUP.tmp
SAVELIST=${BACKDIR}/SaveList.${DATE}

#
# Generate a listing of potential victims for backups....
#
echo "Generating listings..... Looking for SAVEFILES in all modules..."

# Debug stuff
# ls ${TITANHOME}/modules/*

BACKDATA=`grep "SAVEFILES" ${TITANHOME}/modules/* | grep -v "\#" | awk -F"=" '{print $2}' | sort -u | tr -d "'"`
# echo $BACKDATA

#
# Don't even bother to make a backup dir etc... unless we have something to
# do...
COUNT=`echo ${BACKDATA} | wc -w`
if [ $COUNT -ge 1 ]; then
#
# Make a backup dir in $TITANHOME/Backup

if [ -d $BACKDIR ]; then
 echo "Backup dir $BACKDIR - OK"
else
 echo "Creating backup dir in : $BACKDIR"
 /bin/mkdir -p $BACKDIR
fi

#
# Zero out the files we need
#
> ${BACKFILE}
> ${SAVELIST}

#
# Check for files as opposed to directories. Burn block/pipe files so we 
# don't hang on things like /dev/ip, /dev/kmem, /etc/utmppipe etc...

for NAME in ${BACKDATA}; do
	if [ -z "$NAME" -o -d $NAME -o -p $NAME -o -b $NAME ]; then
	 echo "System dir/pipe/special file passing = $NAME"
		# >/dev/null 2>&-
	else
         if [ -f $NAME -o -r $NAME -o -x $NAME -o -h $NAME -o -c $NAME ]; then
           echo $NAME | tr -d ' ' >>${BACKFILE}
	   
         fi
	fi
done

#
# Now take a cleaner list and make dir's, copy files etc....
#
BACKCOUNT=0
nawk 'BEGIN {printf("Backing up $COUNT files now and...")}' /dev/null
nawk 'BEGIN {printf("Set default perms on copies to 600 and ...")}' /dev/null
nawk 'BEGIN {printf("Get ACLs/Make setfacl list for untit.sh...")}' /dev/null

for FILE in `sort -u ${BACKFILE}`
 do
   BACKCOUNT=`expr ${BACKCOUNT} + 1`
   /usr/bin/echo "${BACKCOUNT} \c" 
   BASENAME=`basename ${FILE}`
   AWKNAME=`echo $FILE | \
   awk -F"/" '{for ( i = 1; i < NF; ++i ) printf("/%s",$i) }'`
   DIRNAME=`echo $AWKNAME | sed -e 's/^\///'`
   /bin/mkdir -p ${BACKDIR}${DIRNAME}
   /bin/cp -p ${FILE} ${BACKDIR}${DIRNAME}/${BASENAME}
   /bin/chmod 600 ${BACKDIR}${DIRNAME}/${BASENAME}

# Get original file ACL information and create a setfacl list in SAVELIST
   if [ -x /bin/getfacl ]; then
    /usr/bin/echo "setfacl -s \c" >>${SAVELIST}
    for name in `/bin/getfacl $FILE | awk '{print $1}' | grep -v "#"`;do
    /usr/bin/echo "$name,\c" >>${SAVELIST}
    done
  fi
   # Debug stuff here
    /usr/bin/echo " ${FILE}" >>${SAVELIST}
done

echo " Done!!"

#
# Cleanup leading '/' in SAVELIST such that we can 
# use cpio, tar etc.. to recover files to original locations
#

#
# Tell me what we did...
#
for CLEAN in ${BACKFILE}
 do
 if [ -r ${CLEAN} ]; then
 /bin/rm -f ${CLEAN}
 echo "..."
 fi
done
echo "Saved off ${BACKCOUNT} files to: ${BACKDIR}"
echo "See details: ${SAVELIST}"
echo "Restore by running ${TITANHOME}/lib/untit.sh -[g,r]"

#
# Let people know that backtit.sh needs a variable now...
#
else

echo "No files listed in modules.. Nothing to backup..."
echo "You might want to add a SAVEFILES variable to your modules"
echo "Something like this: SAVEFILE='/etc/motd /usr/aset/asetenv'"
echo ""
echo "Backtit.sh now only looks for this variable and does not attempt"
echo "to calculate files to backup by reading the contents of modules"

fi

# finis
exit 0
