:
# ziplock.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# revision 3.01 Tue Nov  3 17:51:49 PST 1998
#	took out the pipe to more and the read, just echo the files
#	right now when run -v.  Need to fix this whole module to use
#	t_echo.
# version 3.0.2 Thu Nov  5 12:32:00 PST 1998 bpowell added t_echo
# version 3.0.7 Thu Apr 15 08:42:50 PDT 1999 Tax Day Yikes! bpowell
#               added back in the pt_chmod suid bit so windows work
#               for common users see line 132 for info
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES=''
OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

 
Intro(){
cat << EOF

 $MYNAME : The final step in tightening - READ CAREFULLY
 This program absolutely tightens perms for much of the OS

 Caution after this is run ONLY root and group STAFF will be able
 run many system functions!!!

 You may wish to make sure the group "staff" exists and you are currently
 In the group "staff" before proceeding.

EOF

}

FixSuid() {
# Place suid files that need to be restricted in the list below.

t_echo 2 " "
t_echo 2 "Setting file attributes on suid objects"
t_echo 2 "This is done both to slow down a cracker entering as a non-root user"
t_echo 2 "as well as ensure that if a bug exists in one of these files that it"
t_echo 2 "cannot be exploited to gain root (well we make it tougher anyway)"
t_echo 2 " "

while read file mode user group type; do
        #
        #       If the object does not exist on this system then skip it.
        #
        if [ ! -d "$file" -a ! -f "$file" ]; then
                continue;
        fi

        t_echo  2  "       $file"

        #
        #       If the object is a symbolic link then do not chmod(1) it.
        #
        if [ "$type" != "symlink" ]; then
                chmod "$mode" "$file"
                #
                #       If the mode has the setgid bit set, then use
                #       symbolic mode to set it.
                #
                if [ "`echo $mode | cut -c2`" = "2" ]; then
                        chmod g+s "$file"
                fi

                t_echo 2  " (mode)"
        fi
        chown "$user:$group" "$file"
        echo " (ownership)"
done << EOF_SUID
/usr/bin/at 0750 root staff file
/usr/kvm/eeprom 0750 root staff file
/sbin/su 4750 root staff file
/usr/bin/atq 0750 root staff file
/usr/bin/atrm 0750 root staff file
/usr/bin/chkey 0750 root staff file
/usr/bin/crontab 4750 root staff file
/usr/bin/eject 4750 root staff file
/usr/bin/fdformat 0700 root staff file
/usr/bin/newgrp 0700 root staff file
/usr/bin/ps 4750 root staff file
/usr/bin/rcp 0700 root staff file
/usr/bin/rdist 0100 root staff file
/usr/bin/rlogin 4750 root staff file
/sbin/sulogin 0700 root staff file
# /usr/bin/login 4755 root bin file
#/usr/bin/login 0550 root staff file
/usr/bin/rsh 4750 root staff file
/usr/bin/su 4750 root staff file
/usr/bin/tip 0700 root staff file
/usr/bin/uptime 4750 root staff file
/usr/bin/yppasswd 0700 root staff file
/usr/bin/w 4750 root staff file
/usr/bin/ct 0700 root staff file
/usr/bin/cu 0700 root staff file
/usr/bin/uucp 4700 root staff file
/usr/bin/uuglist 4700 root staff file
/usr/bin/uuname 4700 root staff file
/usr/bin/uustat 4750 root staff file
/usr/bin/uux 0700 root staff file
/usr/lib/exrecover 0750 root staff file
#/usr/lib/exrecover 0100 root staff file
/usr/lib/fs/ufs/ufsdump 0750 root staff file
/usr/lib/fs/ufs/ufsrestore 0750 root staff file

# to allow users to use window systems use this
/usr/lib/pt_chmod 4711 root staff file

# If root is the only one using windows then this is better
# /usr/lib/pt_chmod 0700 root staff file

/usr/lib/sendmail.mx 4750 root staff file
/usr/lib/acct/accton 4750 root adm file
/usr/sbin/allocate 4750 root staff file
# /usr/sbin/mkdevalloc 4750 root staff file
/usr/sbin/mkdevalloc 0700 root staff file
# /usr/sbin/mkdevmaps 4750 root staff file
/usr/sbin/mkdevmaps 0700 root staff file
/usr/sbin/ping 4750 root staff file
/usr/sbin/traceroute 4510 root staff file
/usr/sbin/sacadm 4750 root staff file
/usr/sbin/static/rcp 0700 root staff file
/usr/sbin/whodo 4750 root staff file
/usr/sbin/deallocate 4750 root staff file
/usr/sbin/list_devices 4750 root staff file
/usr/openwin/bin/xlock 0700 root staff file
/usr/openwin/bin/xdm 0100 root staff file
/usr/openwin/lib/mkcookie 2750 root sys file
# /usr/openwin/lib/mkcookie 4750 root staff file
/usr/ucb/ps 4750 root staff file
/usr/vmsys/bin/chkperm 4750 root staff file
/usr/bin/passwd 4755 root staff file 
/usr/bin/csh 0755 root staff file 
/etc/lp/alerts/printer 0755 root staff file
/usr/dt/bin/sdtcm_convert 0755 root staff file
/usr/dt/bin/dtprintinfo 0755 root staff file
EOF_SUID

}

FixGid() {

t_echo 2 " "
t_echo 2 "Set GROUP id on file section. Less of a problem, but things that"
t_echo 2 "are sgid kmem for example can potentially read root memory"
t_echo 2 "Some others could be used by crackers to find about the system"
t_echo 2 "so we restrict these to root and staff use"
t_echo 2 " "

while read file mode user group type; do
        #
        #       If the object does not exist on this system then skip it.
        #
        if [ ! -d "$file" -a ! -f "$file" ]; then
                continue;
        fi
 
        t_echo 2  "       $file"
 
        #
        #       If the object is a symbolic link then do not chmod(1) it.
        #
        if [ "$type" != "symlink" ]; then
                chmod "$mode" "$file"
                #
                #       If the mode has the setgid bit set, then use
                #       symbolic mode to set it.
                #
                if [ "`echo $mode | cut -c2`" = "2" ]; then
                        chmod g+s "$file"
                fi
 
                t_echo 2  " (mode)"
        fi
        chown "$user:$group" "$file"
done << EOF_SGID
/usr/kvm/crash 02700 root sys file
/usr/kvm/eeprom 02700 root sys file
/usr/bin/netstat 0750 root staff file
/usr/bin/nfsstat 2750 root sys file
/usr/bin/write 2750 root tty file
/usr/bin/ipcs 2750 root sys file
/usr/sbin/arp 2750 root bin file
/usr/sbin/prtconf 2750 root sys file
/usr/sbin/swap 2750 root sys file
/usr/sbin/sysdef 2750 root sys file
/usr/sbin/wall 2700 root tty file
/usr/sbin/dmesg 2700 root sys file
/usr/openwin/bin/Xsun 2750 root root file

# if No dtlogin or xdm, then this is better 
# /usr/openwin/bin/Xsun 0755 root root file

# /usr/openwin/bin/wsinfo 2750 root sys file
/usr/openwin/bin/wsinfo 0750 root staff file
/usr/openwin/bin/mailtool 2750 root sys file
/usr/openwin/bin/xload 2750 root sys file
/usr/openwin/bin/kcms_calibrate 0500 root sys file
/usr/openwin/bin/kcms_configure 0500 root sys file
/usr/openwin/bin/kcms_server 0500 root sys file
/var/adm/messages 0640 root staff file
/var/log/syslog 0640 root staff file
/var/adm/pacct 0640 root staff file
EOF_SGID

}

VrfyMisc() {

t_echo 1 " "
t_echo 1 "Unfortunately this is a FIX ONLY utility....."
t_echo 1 "As noted in the Introduction statement it may break functionality"
t_echo 1 "for all non-root users if run -F "
t_echo 1 " "
t_echo 1 "The list of files is as follows and may be manually modified"
t_echo 1 "by editing this script and inserting/commenting out as you"
t_echo 1 "like. Just make sure you know what it is you are changing:"
t_echo 1 " "
t_echo 1 "The list of binaries that would be modified is:"
t_echo 1 " "

egrep '(file|symlink|dir)' ${0} | grep root | egrep -v '(^#|^egrep)' | awk '{print $1}'

}

action=$1
case $action in
 -[Ii]*)
 Intro
 ;;
 -[Ff]*)
 FixSuid
 FixGid
 ;;
-[Vv]*)
 VrfyMisc
 ;;
	*)
        t_echo 1 " ERROR:Invalid arg $action"
        t_echo 1 " ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
;;
esac
